'use strict';

var _enzymeMatchers = require('enzyme-matchers');

var _enzymeMatchers2 = _interopRequireDefault(_enzymeMatchers);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; } /* eslint-disable new-cap */
/**
 * This source code is licensed under the MIT-style license found in the
 * LICENSE file in the root directory of this source tree. *
 *
 * @providesModule setupTestFrameworkScriptFile
 * 
 */

// add methods!
beforeEach(function () {
  var matchers = {};

  Object.keys(_enzymeMatchers2.default).forEach(function (matcherKey) {
    var matcher = _defineProperty({}, matcherKey, function (wrapper) {
      for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      var result = _enzymeMatchers2.default[matcherKey].apply(_enzymeMatchers2.default, [wrapper].concat(args));

      if (this.isNot) {
        result.message = result.negatedMessage;
      }

      if (result.contextualInformation.expected) {
        result.message += '\n' + this.utils.RECEIVED_COLOR(result.contextualInformation.expected);
      }

      if (result.contextualInformation.actual) {
        result.message += '\n' + this.utils.EXPECTED_COLOR(result.contextualInformation.actual);
      }

      return result;
    })[matcherKey];

    matchers[matcherKey] = matcher;
  });

  expect.extend(matchers);
});