'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

exports.default = toMatchSnapshot;

var _enzymeToJson = require('enzyme-to-json');

var _enzymeToJson2 = _interopRequireDefault(_enzymeToJson);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var GLOBAL_STATE = Symbol.for('$$jest-matchers-object');
var originalToMatchSnapshot = global[GLOBAL_STATE].matchers.toMatchSnapshot;

function isEnzyme(wrapper) {
  if ((typeof wrapper === 'undefined' ? 'undefined' : _typeof(wrapper)) !== 'object' || Array.isArray(wrapper)) {
    return false;
  }

  return !!(wrapper.node && Array.isArray(wrapper.nodes) && wrapper.complexSelector);
}

function toMatchSnapshot(maybeEnzymeWrapper) {
  var snapshotableValue = maybeEnzymeWrapper;
  if (isEnzyme(maybeEnzymeWrapper)) {
    snapshotableValue = (0, _enzymeToJson2.default)(maybeEnzymeWrapper);
  }

  return originalToMatchSnapshot.call(this, snapshotableValue);
}
module.exports = exports['default'];